/**
 * Copyright (c) 2006 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * History:
 * 2007-01-29 [KS] umbenannt in AtgLangZeitDatenGeschwindigkeit (Z+D groß)
 *
 * $Log: AtgLangZeitDatenGeschwindigkeit.java,v $
 * Revision 1.1  2007/07/04 11:42:25  Trier
 * Neuordnung
 *
 * Revision 1.1.1.1  2007/06/20 09:56:26  Trier
 * dvs alles
 *
 * Revision 1.2  2007/06/12 08:49:40  Strey
 * __ATTR_NAMEN für generischen Zugriff auf pblic gesetzt
 *
 * Revision 1.1  2006/08/28 13:43:58  Schawaller
 * Neue klasse zum kapseln von ATG
 *
 */

package de.bsvrz.dua.bastband.bastband.dvs.funclib.datawrapper;

import de.bsvrz.dav.daf.main.Data;

/**
 *
 * Die Klasse kapselt die Attributgruppe
 * <code>atg.langZeitDatenGeschwindigkeit</code>.
 *
 * <p>
 * Copyright: Copyright (c) 2006
 * </p>
 *
 * <p>
 * Organisation: Logos GmbH Rostock (www.logos-ib.de)
 * </p>
 *
 * @author J.Schawaller
 * @version 1.0
 */
public class AtgLangZeitDatenGeschwindigkeit extends AtgGeschwindigkeitenLangzeitdaten {

	/**
	 * ATG_PID_LangZeitDatenGeschwindigkeit - PID dieser ATG
	 */
	private static final String ATG_PID_LANG_ZEIT_DATEN_GESCHWINDIGKEIT = "atg.langZeitDatenGeschwindigkeit";

	/**
	 * Erzeugt neue Instanz der Klasse.
	 */
	public AtgLangZeitDatenGeschwindigkeit() {
		super();
	}

	/**
	 * Erzeugt neue Instanz der Klasse mit dem <code>data</code>.
	 * 
	 * @param data
	 *            die Daten
	 */
	public AtgLangZeitDatenGeschwindigkeit(final Data data) {
		super(data);
	}

	/**
	 * Gibt die PID dieser ATG wieder.
	 *
	 * @return String PID der ATG
	 */
	@Override
	public String getAtgPid() {
		return AtgLangZeitDatenGeschwindigkeit.ATG_PID_LANG_ZEIT_DATEN_GESCHWINDIGKEIT;
	}

}
