/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.bsvrz.dua.bastband.bastband.dvs.funclib.datawrapper;

/**
 * History:
 *
 * $Log: ValueRangeHashtable.java,v $
 * Revision 1.1  2007/07/04 11:43:27  Trier
 * Neuordnung
 *
 * Revision 1.1.1.1  2007/06/20 09:56:27  Trier
 * dvs alles
 *
 * Revision 1.3  2006/11/13 09:24:12  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.2  2005/01/25 09:43:11  Trier
 * <Kein Kommentar eingegeben>
 *
 * Revision 1.1.1.1  2004/03/23 13:14:19  Trier
 * Basis für LogosApps
 *
 * Revision 1.1.1.1  2004/03/23 07:59:52  Trier
 * vrz
 *
 */

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.IntegerAttributeType;
import de.bsvrz.dav.daf.main.config.IntegerValueRange;

/**
 * Klasse zum Cachen der IntegerValueRange f&uuml;r Attribute.
 */
public class ValueRangeHashtable extends java.lang.Object {

	private static DataModel __DataModel;
	private static java.util.Hashtable<String, IntegerValueRange> hashtable;

	private static ValueRangeHashtable instance;

	private ValueRangeHashtable(final Data data) {
		if (data.isPlain()) {
			ValueRangeHashtable.__DataModel = data.getAttributeType()
					.getDataModel();
			ValueRangeHashtable.hashtable = new java.util.Hashtable<String, IntegerValueRange>();
		} else {
			throw new java.lang.IllegalArgumentException(
					"data.isPlain must be true");
		}
	}

	public static ValueRangeHashtable getInstance(final Data data)
			throws IllegalArgumentException {
		if (ValueRangeHashtable.instance == null) {
			ValueRangeHashtable.instance = new ValueRangeHashtable(data);
		}
		return ValueRangeHashtable.instance;
	}

	public IntegerValueRange get(final String attributePid)
			throws IllegalArgumentException {
		IntegerValueRange oValueRange;
		final Object o = ValueRangeHashtable.hashtable.get(attributePid);
		if (o == null) {
			try {
				final IntegerAttributeType oIntAttrType = (IntegerAttributeType) ValueRangeHashtable.__DataModel
						.getAttributeType(attributePid);
				if (oIntAttrType == null) {
					throw new IllegalArgumentException("AttributeType "
							+ attributePid + " not defined in DataModel");
				} else {
					oValueRange = oIntAttrType.getRange();
					ValueRangeHashtable.hashtable.put(attributePid,
							oValueRange);
				}
			} catch (final ClassCastException e) {
				throw new IllegalArgumentException(
						"attributePID mus PID of an IntegerAttributeType");
			}
		} else {
			oValueRange = (IntegerValueRange) o;
		}
		return oValueRange;
	}

}
