/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.bsvrz.dua.bastband.bastband.dvs.funclib.objectwrapper;

import java.util.Hashtable;

import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;

/**
 * kapselt die unterschiedlichen Typen der FG01 (Lufttemperatur,
 * Fahrbahnoberfl&auml;chentemperatur, Windgeschwindigkeit usw).
 */
public class FG03Type {

	public static final String ATGSTRING_TYP35 = "atg.tlsUfdErgebnisMeldungTyp35";
	public static final String ATGSTRING_LUFTTEMPERATUR_LT = "atg.tlsUfdErgebnisMeldungLuftTemperaturLT";
	public static final String ATGSTRING_FAHRBAHN_OBERFLAECHENTEMPERATUR_FBT = "atg.tlsUfdErgebnisMeldungFahrbahnOberFlächenTemperaturFBT";
	public static final String ATGSTRING_TYP50 = "atg.tlsUfdErgebnisMeldungTyp50";
	public static final String ATGSTRING_FAHRBAHN_OBERFLAECHE = "atg.tlsUfdErgebnisMeldungFahrbahnOberFläche";
	public static final String ATGSTRING_RESTSALZ_RS = "atg.tlsUfdErgebnisMeldungRestSalzRS";
	public static final String ATGSTRING_NIEDERSCHLAGSINTENSITAET_NI = "atg.tlsUfdErgebnisMeldungNiederschlagsIntensitätNI";
	public static final String ATGSTRING_LUFTDRUCK_LD = "atg.tlsUfdErgebnisMeldungLuftDruckLD";
	public static final String ATGSTRING_RELATIVE_LUFTFEUCHTE_RLF = "atg.tlsUfdErgebnisMeldungRelativeLuftFeuchteRLF";
	public static final String ATGSTRING_WIND_RICHTUNG_WR = "atg.tlsUfdErgebnisMeldungWindRichtungWR";
	public static final String ATGSTRING_WIND_GESCHWINDIGKEIT_MITTEL_WERT_WGM = "atg.tlsUfdErgebnisMeldungWindGeschwindigkeitMittelWertWGM";
	public static final String ATGSTRING_SCHNEEHOEHE_SH = "atg.tlsUfdErgebnisMeldungSchneeHöheSH";
	public static final String ATGSTRING_TYP59 = "atg.tlsUfdErgebnisMeldungTyp59";
	public static final String ATGSTRING_SICHTWEITE_SW = "atg.tlsUfdErgebnisMeldungSichtWeiteSW";
	public static final String ATGSTRING_HELLIGKEIT_HK = "atg.tlsUfdErgebnisMeldungHelligkeitHK";
	public static final String ATGSTRING_TYP62 = "atg.tlsUfdErgebnisMeldungTyp62";

	public static final String ATGSTRING_NIEDERSCHLAG = "atg.tlsUfdErgebnisMeldungNiederschlag";
	public static final String ATGSTRING_WIND_GESCHWINDIGKEIT_SPITZEN_WERT_WGS = "atg.tlsUfdErgebnisMeldungWindGeschwindigkeitSpitzenWertWGS";
	public static final String ATGSTRING_GEFRIER_TEMPERATUR_GT = "atg.tlsUfdErgebnisMeldungGefrierTemperaturGT";
	public static final String ATGSTRING_TAUPUNKT_TEMPERATUR_TPT = "atg.tlsUfdErgebnisMeldungTaupunktTemperaturTPT";
	public static final String ATGSTRING_TEMPERATUR_IN_TIEFE1_TT1 = "atg.tlsUfdErgebnisMeldungTemperaturInTiefe1TT1";
	public static final String ATGSTRING_TEMPERATUR_IN_TIEFE_2_TT2 = "atg.tlsUfdErgebnisMeldungTemperaturInTiefe2TT2";
	public static final String ATGSTRING_TEMPERATUR_IN_TIEFE_3_TT3 = "atg.tlsUfdErgebnisMeldungTemperaturInTiefe3TT3";
	public static final String ATGSTRING_ZUSTAND_DER_FAHRBAHN_OBERFLAECHE_FBZ = "atg.tlsUfdErgebnisMeldungZustandDerFahrbahnOberFlächeFBZ";
	public static final String ATGSTRING_NIEDERSCHLAGS_ART_NS = "atg.tlsUfdErgebnisMeldungNiederschlagsArtNS";
	public static final String ATGSTRING_WASSER_FILM_DICKE_WFD = "atg.tlsUfdErgebnisMeldungWasserFilmDickeWFD";
	public static final String ATGSTRING_ZEITRESERVE_GLAETTE_ZG = "atg.tlsUfdErgebnisMeldungZeitreserveGlätteZG";
	public static final String ATGSTRING_ZUSTAND_DER_FAHRBAHN_OBER_FLAECHE_FBZ_VAISALA = "atg.tlsUfdErgebnisMeldungZustandDerFahrbahnOberFlächeFBZVaisala";
	public static final String ATGSTRING_FAHRBAHN_GLAETTE_MICKS = "atg.tlsUfdErgebnisMeldungFahrbahnGlätteFBGMicKS";
	public static final String ATGSTRING_ZEITRESERVE_GLAETTE_ZGMICKS = "atg.tlsUfdErgebnisMeldungZeitreserveGlätteZGMicKS";

	// Vaisala
	public static final String ATGSTRING_NIEDERSCHLAG_SUMME_VAISALA = "atg.tlsUfdErgebnisMeldungNiederschlagSummeVaisala";
	public static final String ATGSTRING_MENGE_ENTEISUNGSMITTEL_VAISALA = "atg.tlsUfdErgebnisMeldungMengeEnteisungsmittelVaisala";
	public static final String ATGSTRING_NWS_CODE_VAISALA = "atg.tlsUfdErgebnisMeldungNWSCodeVaisala";
	public static final String ATGSTRING_INTERNER_SYSTEMSTATUS_VAISALA = "atg.tlsUfdErgebnisMeldungInternerSystemstatusVaisala";
	public static final String ATGSTRING_WMO_CODE_VAISALA = "atg.tlsUfdErgebnisMeldungWMOCodeVaisala";
	public static final String ATGSTRING_LIQUIDUS_TEMPERATUR_VAISALA = "atg.tlsUfdErgebnisMeldungLiquidusTemperaturVaisala";

	public static final short STATUS_OK = 0;
	public static final short STATUS_WARNING = 1;
	public static final short STATUS_ALERT = 2;

	// public static final int INTERPRETING_NONE = 0;
	// public static final int INTERPRETING_HIGHER = 1;
	// public static final int INTERPRETING_LOWER = 2;

	private static Hashtable<String, FG03Type> __MappingTyp = new Hashtable<String, FG03Type>(
			30);

	// public static FG03Type LuftTemp = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ048", "Lufttemperatur", "LT",
	// 48, ATGSTRING_LuftTemperaturLT, false);
	// public static FG03Type FBTemp = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ049",
	// "Fahrbahnoberflächentemperatur", "FBT", 49,
	// ATGSTRING_FahrbahnOberFlächenTemperaturFBT, true);
	// public static FG03Type Restsalz = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ052", "Restsalz", "RS", 52,
	// ATGSTRING_RestSalzRS, true);
	// public static FG03Type NiederschlIntensität = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ053",
	// "Niederschlagsintensität", "NI", 53, ATGSTRING_NiederschlagsIntensitätNI,
	// false);
	// public static FG03Type RelLuftFeuchte = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ055", "Relative Luftfeuchte",
	// "RLF", 55, ATGSTRING_RelativeLuftFeuchteRLF, false);
	// public static FG03Type WindRichtg = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ056", "Windrichtung", "WR", 56,
	// ATGSTRING_WindRichtungWR, false);
	//
	// public static FG03Type WindGeschwMittel = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ057",
	// "Windgeschwindigkeit (Mittel)", "WGM", 57,
	// ATGSTRING_WindGeschwindigkeitMittelWertWGM, false);
	// public static FG03Type WindGeschwSpitze = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ064",
	// "Windgeschwindigkeit (Spitze)", "WGS", 64,
	// ATGSTRING_WindGeschwindigkeitSpitzenWertWGS, false);
	//
	// public static FG03Type GefrierTemp = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ065", "Gefriertemperatur",
	// "GT", 65, ATGSTRING_GefrierTemperaturGT, true);
	// public static FG03Type TaupunktTemp = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ066", "Taupunkttemperatur",
	// "TPT", 66, ATGSTRING_TaupunktTemperaturTPT, false);
	// public static FG03Type TiefenTemp7 = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ067",
	// "Tiefentemperatur (7 cm)", "TT 1", 67, ATGSTRING_TemperaturInTiefe1TT1,
	// true);
	// public static FG03Type TiefenTemp30 = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ069",
	// "Tiefentemperatur (30 cm)", "TT 3", 69, ATGSTRING_TemperaturInTiefe3TT3,
	// true);
	//
	// public static FG03Type NiederschlagsArt = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ071", "Niederschlagsart", "NS",
	// 71, ATGSTRING_NiederschlagsArtNS, false);
	// public static FG03Type WasserFilmDicke = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ072", "Wasserfilmdicke", "WFD",
	// 72, ATGSTRING_WasserFilmDickeWFD, true);
	// public static FG03Type ZeitReserveGlaette = new
	// FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ187MvAntBosch",
	// "Zeitreserve Glätte", "ZRG", 187, ATGSTRING_ZeitreserveGlätteZG, true);
	// public static FG03Type FBZustand = new
	// FG03Type("kex.tls.osi7.conversion.Fg003Typ189",
	// "Zustand Fahrbahnoberfläche", "FBZ", 189,
	// ATGSTRING_ZustandDerFahrbahnOberFlächeFBZ, true);

	String _Name;
	String _Abbreviation;
	String _UmsetzungsModul;
	int _Type;
	AttributeGroup _Atg;
	boolean _IsFahrstreifenSensor;

	static boolean __NotInitialized = true;

	public FG03Type(final String umsetzungsModul, final String name,
			final String abbreviation, final int type, final String atgPid,
			final boolean isFahrstreifenSensor) {
		_UmsetzungsModul = umsetzungsModul;
		_Name = name;
		_Abbreviation = abbreviation;
		_Type = type;
		_IsFahrstreifenSensor = isFahrstreifenSensor;
		final DataModel model = de.bsvrz.dua.bastband.bastband.dvs.funclib.LogosClientDavConnection
				.getInstance().getDataModel();
		try {
			_Atg = model.getAttributeGroup(atgPid);
		} catch (final Exception ex) {
			ex.printStackTrace();
		}
		FG03Type.__MappingTyp.put(_UmsetzungsModul, this);
	}

	public static FG03Type getInstance(final String umsetzungsModul) {
		if (FG03Type.__NotInitialized) {
			FG03Type.init();
		}
		return FG03Type.__MappingTyp.get(umsetzungsModul);
	}

	public boolean isFahrstreifenSensor() {
		return _IsFahrstreifenSensor;
	}

	private synchronized static void init() {
		if (FG03Type.__NotInitialized) {
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ048",
					"Lufttemperatur", "LT", 48,
					FG03Type.ATGSTRING_LUFTTEMPERATUR_LT, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ049",
					"Fahrbahnoberflächentemperatur", "FBT", 49,
					FG03Type.ATGSTRING_FAHRBAHN_OBERFLAECHENTEMPERATUR_FBT, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ052", "Restsalz",
					"RS", 52, FG03Type.ATGSTRING_RESTSALZ_RS, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ053",
					"Niederschlagsintensität", "NI", 53,
					FG03Type.ATGSTRING_NIEDERSCHLAGSINTENSITAET_NI, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ055",
					"Relative Luftfeuchte", "RLF", 55,
					FG03Type.ATGSTRING_RELATIVE_LUFTFEUCHTE_RLF, false);

			new FG03Type("kex.tls.osi7.conversion.Fg003Typ058", "Schneehöhe",
					"SH", 58, FG03Type.ATGSTRING_SCHNEEHOEHE_SH, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ060", "Sichtweite",
					"SW", 60, FG03Type.ATGSTRING_SICHTWEITE_SW, false);

			new FG03Type("kex.tls.osi7.conversion.Fg003Typ056", "Windrichtung",
					"WR", 56, FG03Type.ATGSTRING_WIND_RICHTUNG_WR, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ057",
					"Windgeschwindigkeit (Mittel)", "WGM", 57,
					FG03Type.ATGSTRING_WIND_GESCHWINDIGKEIT_MITTEL_WERT_WGM, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ064",
					"Windgeschwindigkeit (Spitze)", "WGS", 64,
					FG03Type.ATGSTRING_WIND_GESCHWINDIGKEIT_SPITZEN_WERT_WGS, false);

			new FG03Type("kex.tls.osi7.conversion.Fg003Typ065",
					"Gefriertemperatur", "GT", 65,
					FG03Type.ATGSTRING_GEFRIER_TEMPERATUR_GT, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ066",
					"Taupunkttemperatur", "TPT", 66,
					FG03Type.ATGSTRING_TAUPUNKT_TEMPERATUR_TPT, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ067",
					"Tiefentemperatur (7 cm)", "TT 1", 67,
					FG03Type.ATGSTRING_TEMPERATUR_IN_TIEFE1_TT1, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ069",
					"Tiefentemperatur (30 cm)", "TT 3", 69,
					FG03Type.ATGSTRING_TEMPERATUR_IN_TIEFE_3_TT3, true);

			new FG03Type("kex.tls.osi7.conversion.Fg003Typ063",
					"Niederschlagsart", "NSA", 63,
					FG03Type.ATGSTRING_NIEDERSCHLAG, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ071",
					"Niederschlagsart", "NS", 71,
					FG03Type.ATGSTRING_NIEDERSCHLAGS_ART_NS, false);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ072",
					"Wasserfilmdicke", "WFD", 72,
					FG03Type.ATGSTRING_WASSER_FILM_DICKE_WFD, true);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ187MvAntBosch",
					"Zeitreserve Glätte", "ZRG", 187,
					FG03Type.ATGSTRING_ZEITRESERVE_GLAETTE_ZG, true);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ187",
					"Zeitreserve Glätte", "ZRG", 187,
					FG03Type.ATGSTRING_ZEITRESERVE_GLAETTE_ZG, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ187",
					"Zeitreserve Glätte", "ZRG", 187,
					FG03Type.ATGSTRING_ZEITRESERVE_GLAETTE_ZG, true);
			// FBZustand = new FG03Type("kex.tls.osi7.conversion.Fg003Typ189",
			// "Zustand Fahrbahnoberfläche", "FBZ", 189,
			// ATGSTRING_ZustandDerFahrbahnOberFlächeFBZ);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ182MvMicKS",
					"Zeitreserve Glätte", "ZRG", 182,
					FG03Type.ATGSTRING_FAHRBAHN_GLAETTE_MICKS, true);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ132MvMicKS",
					"Fahrbahnglätte", "FBG", 122,
					FG03Type.ATGSTRING_ZEITRESERVE_GLAETTE_ZGMICKS, true);

			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ189Mv",
					"Zustand Fahrbahnoberfläche", "FBZ", 189,
					FG03Type.ATGSTRING_ZUSTAND_DER_FAHRBAHN_OBER_FLAECHE_FBZ_VAISALA,
					true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ051",
					"Zustand Fahrbahnoberfläche", "FBZ", 52,
					FG03Type.ATGSTRING_FAHRBAHN_OBERFLAECHE, true);
			new FG03Type("kex.tls.osi7.conversion.Fg003Typ070",
					"Zustand Fahrbahnoberfläche", "FBZ", 70,
					FG03Type.ATGSTRING_ZUSTAND_DER_FAHRBAHN_OBERFLAECHE_FBZ, true);

			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ130MvVaisala",
					"Niederschlagssumme", "", -1,
					FG03Type.ATGSTRING_NIEDERSCHLAG_SUMME_VAISALA, false);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ131MvVaisala",
					"Menge der Chemikalien (CE1)", "", -1,
					FG03Type.ATGSTRING_MENGE_ENTEISUNGSMITTEL_VAISALA, false);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ132MvVaisala",
					"Niederschlag NWS Codes", "", -1,
					FG03Type.ATGSTRING_NWS_CODE_VAISALA, false);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ133MvVaisala",
					"FDS Status", "", -1,
					FG03Type.ATGSTRING_INTERNER_SYSTEMSTATUS_VAISALA, false);
			new FG03Type("kex.tls.osi7.conversion.mv.Fg003Typ134MvVaisala",
					"WMO Codes", "", -1, FG03Type.ATGSTRING_WMO_CODE_VAISALA,
					false);
			new FG03Type(
					"kex.tls.osi7.conversion.mv.Fg003Typ65LiquidusMvVaisala",
					"Gefriertemperatur (Tf1)", "", -1,
					FG03Type.ATGSTRING_LIQUIDUS_TEMPERATUR_VAISALA, false);

		}
		FG03Type.__NotInitialized = false;
	}

	public final String getUmsetzungsModul() {
		return _UmsetzungsModul;
	}

	/**
	 * Typ der FG01 (Was wurde gemessen).
	 *
	 * @return Lufttemperatur, Dahrbahnoberfl&auml;chentemperatur, Restsalz usw)
	 */
	public final String getName() {
		return _Name;
	}

	public final String getAbbreviation() {
		return _Abbreviation;
	}

	public final int getType() {
		return _Type;
	}

	public final AttributeGroup getAtg() {
		return _Atg;
	}

	@Override
	public String toString() {
		final StringBuffer sb = new StringBuffer("FG03Type(");
		sb.append(_UmsetzungsModul).append(" - ");
		sb.append(_Name).append(" - ");
		sb.append(_Abbreviation).append(" - ");
		sb.append(_Type).append(" - ");
		sb.append(_Atg.getPid());
		sb.append(")");
		return sb.toString();
	}

}
